SystemOrganization addCategory: #'Xenon-Core'!
SystemOrganization addCategory: #'Xenon-Core-Types'!
SystemOrganization addCategory: #'Xenon-Core-Translation to C'!
SystemOrganization addCategory: #'Xenon-Core-Semantic'!
SystemOrganization addCategory: #'Xenon-Core-Semantic-Binding'!
SystemOrganization addCategory: #'Xenon-Core-Semantic-Scope'!
SystemOrganization addCategory: #'Xenon-Core-Semantic-Exceptions'!
SystemOrganization addCategory: #'Xenon-Core-Writer'!
SystemOrganization addCategory: #'Xenon-Core-Platform'!

Trait named: #XeDefineOnCG
	uses: {}
	category: 'Xenon-Core'!

!XeDefineOnCG commentStamp: 'BernardoContreras 6/20/2012 00:48' prior: 0!
To define more things in the code generator.
Use it in the class side of a class or a trait.
For instance, add more header files.
!

!XeDefineOnCG methodsFor: 'translation' stamp: 'BernardoContreras 6/19/2012 23:57'!
defineOn: cg
! !

Trait named: #XeTAssert
	uses: {}
	category: 'Xenon-Core-Platform'!

XeTAssert classTrait
	uses: XeDefineOnCG!

!XeTAssert classSide methodsFor: 'translation' stamp: 'BernardoContreras 6/20/2012 01:21'!
defineOn: cg
	cg addHeaderFile: '<assert.h>'! !

!XeTAssert methodsFor: 'assert' stamp: 'BernardoContreras 6/20/2012 00:52'!
assert: expression
	<doNotTranslate>
	expression
		ifFalse: [ Abort signal ]! !

Trait named: #XeTMain
	uses: {}
	category: 'Xenon-Core-Platform'!

!XeTMain commentStamp: 'BernardoContreras 6/19/2012 22:51' prior: 0!
Provides the main method for c without a prototype declaration.
You should implement the mainEntry message in your class.
!

!XeTMain methodsFor: 'main' stamp: 'BernardoContreras 6/19/2012 22:49'!
main
	<noFunctionPrototype>
	<returnType:#int>
	^ self mainEntry	
! !

Trait named: #XeTStdio
	uses: {}
	category: 'Xenon-Core-Platform'!

!XeTStdio commentStamp: '<historical>' prior: 0!
The <stdio.h> Header File
ANSI-compatible file and TTY input/output routines!

XeTStdio classTrait
	uses: XeDefineOnCG!

!XeTStdio classSide methodsFor: 'translation' stamp: 'BernardoContreras 6/20/2012 01:21'!
defineOn: cg
	cg addHeaderFile: '<stdio.h>'! !

!XeTStdio methodsFor: 'stdio' stamp: 'BernardoContreras 6/19/2012 23:32'!
puts: aString
	"Write a string, followed by a newline, to stdout."

	<doNotTranslate>
	Smalltalk tools transcript
		show: aString;
		cr! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/5/2012 15:47'!
cFunctionName
	"Create a C function name from the given selector by omitting colons"
	^ self selector copyWithout: $:
! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/16/2012 18:37'!
defaultReturnType
	^ self propertyAt: #xeDefaultReturnType
	! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/16/2012 18:36'!
defaultReturnType: aXeType 
	self propertyAt: #xeDefaultReturnType put: aXeType! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/19/2012 22:41'!
doNotEmitFunctionPrototype
	self propertyAt: #xeDoNotEmitFunctionPrototype put: false! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/18/2012 21:12'!
doNotTranslate
	self propertyAt: #xeTranslate put: false! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/18/2012 21:50'!
emitDeclarationOn: writer
	self returnType emitOn: writer.
	writer space.
	writer nextPutAll: self cFunctionName.
	writer nextPut: $(.
	self arguments isEmpty
		ifTrue: [ #void asXeType emitOn: writer ]
		ifFalse: [ self arguments do: [ :each | each emitDeclarationOn: writer ] separatedBy: [ writer nextPutAll: ', ' ] ].
	writer nextPut: $)! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/19/2012 22:46'!
emitFunctionPrototypeOn: writer
	self shouldTranslate & self shouldEmitFunctionPrototype
		ifTrue: [ 
			self emitDeclarationOn: writer.
			writer endOfStatement ]! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/16/2012 18:40'!
returnType
	^ (self xeScope lookup: 'returnType' ifAbsent: [ self defaultReturnType ]) asXeType! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/19/2012 22:45'!
shouldEmitFunctionPrototype
	^ self propertyAt: #xeDoNotEmitFunctionPrototype ifAbsent: [ true ]! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/18/2012 21:12'!
shouldTranslate
	^ self propertyAt: #xeTranslate ifAbsent: [ true ]! !

!ByteSymbol methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/22/2012 00:59'!
asXeType
	^ XeType name: self asString
	! !

!String methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/16/2012 19:46'!
asCLiteralValueFor: cg
 	^ '"', self, '"'
	! !

Notification subclass: #XeUndeclaredVariableNotification
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Exceptions'!

!XeUndeclaredVariableNotification commentStamp: 'BernardoContreras 5/12/2012 23:02' prior: 0!
stolen from AST-Semantic!

!XeUndeclaredVariableNotification class methodsFor: 'signalling' stamp: 'BernardoContreras 6/8/2012 09:49'!
node: aVariableNode
	^ self new
		node: aVariableNode;
		signal: aVariableNode name , ' is undeclared'! !

!XeUndeclaredVariableNotification methodsFor: 'exceptiondescription' stamp: 'BernardoContreras 4/15/2012 01:57'!
defaultAction
	^ XeUndeclaredBinding node: self node! !

!XeUndeclaredVariableNotification methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 21:13'!
node
	^ node! !

!XeUndeclaredVariableNotification methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 21:13'!
node: aNode
	node := aNode! !

RBProgramNodeVisitor subclass: #XeSemanticAnnotator
	instanceVariableNames: 'scope cg'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic'!

!XeSemanticAnnotator commentStamp: 'BernardoContreras 4/21/2012 03:20' prior: 0!
To annotate the code with types.

!

!XeSemanticAnnotator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/14/2012 20:45'!
acceptBlockNode: aNode
	self scope: aNode with: XeBlockScope during: [ super acceptBlockNode: aNode ]! !

!XeSemanticAnnotator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 6/18/2012 22:15'!
acceptMethodNode: aNode
	self
		scope: aNode
		with: XeMethodScope
		during: [ 
			super acceptMethodNode: aNode.
			aNode defaultReturnType: cg defaultReturnType ]! !

!XeSemanticAnnotator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 6/19/2012 22:42'!
acceptPragmaNode: aPragmaNode
	aPragmaNode isReturnType
		ifTrue: [ aPragmaNode xeScope add: (XeReturnTypeBinding returnType: aPragmaNode returnType) ].
	aPragmaNode isVarType
		ifTrue: [ aPragmaNode xeScope add: (XeVarTypeBinding varName: aPragmaNode varName type: aPragmaNode varType) ].
	aPragmaNode isDoNotTranslate
		ifTrue: [ aPragmaNode parent doNotTranslate ].
	aPragmaNode isNoFunctionPrototype
		ifTrue: [ aPragmaNode parent doNotEmitFunctionPrototype ]! !

!XeSemanticAnnotator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 6/16/2012 18:16'!
acceptSequenceNode: aNode
	aNode temporaries do: [ :each | scope add: (XeTemporaryBinding node: each type: cg defaultType) ].
	aNode statements do: [ :each | self visitNode: each ]! !

!XeSemanticAnnotator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 6/18/2012 22:15'!
acceptVariableNode: aNode
	| binding |
	binding := scope lookup: aNode name ifAbsent: [ self undeclaredVariable: aNode ].
	aNode xeVariableBinding: binding.
	binding addAccessor: aNode.
	aNode isUsed
		ifTrue: [ binding addReader: aNode ].
	aNode isWrite
		ifTrue: [ binding addWriter: aNode ]! !

!XeSemanticAnnotator methodsFor: 'accessing' stamp: 'BernardoContreras 6/16/2012 18:13'!
cg: aCodeGenerator
	cg := aCodeGenerator.! !

!XeSemanticAnnotator methodsFor: 'private' stamp: 'BernardoContreras 4/14/2012 20:24'!
scope: aNode with: aClass during: aBlock
	scope := aClass owner: scope node: aNode.
	^ aBlock ensure: [ scope := scope owner ]! !

!XeSemanticAnnotator methodsFor: 'visiting' stamp: 'BernardoContreras 4/14/2012 20:24'!
start: aProgramNode
	self visitNode: aProgramNode methodNode! !

!XeSemanticAnnotator methodsFor: 'visiting' stamp: 'BernardoContreras 4/14/2012 20:24'!
start: aProgramNode scope: aLexicalScope
	scope := aLexicalScope.
	self start: aProgramNode! !

!XeSemanticAnnotator methodsFor: 'private' stamp: 'BernardoContreras 6/16/2012 15:22'!
undeclaredVariable: aNode
	^ aNode xeScope add: (XeUndeclaredVariableNotification node: aNode)! !

!XeSemanticAnnotator methodsFor: 'visiting' stamp: 'BernardoContreras 6/18/2012 22:15'!
visitArgument: aNode
	scope add: (XeArgumentBinding node: aNode type: cg defaultType)! !

RBProgramNodeVisitor subclass: #XeTranslator
	instanceVariableNames: 'writer translationDict cg'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Translation to C'!

!XeTranslator commentStamp: '<historical>' prior: 0!
To translate to C Code on a writer
!

!XeTranslator class methodsFor: 'instance creation' stamp: 'BernardoContreras 6/16/2012 19:37'!
newFor: aWriter and: aCodeGenerator 
	" a new instance for the given writer and code generator"

	^ self new
		writer: aWriter;
		cg: aCodeGenerator;
		yourself! !

!XeTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 6/12/2012 23:43'!
acceptAssignmentNode: anAssignmentNode
	anAssignmentNode needsParenthesis
		ifTrue: [ writer nextPut: $( ].
	self visitNode: anAssignmentNode variable.
	writer nextPutAll: ' = '.
	self visitNode: anAssignmentNode value.
	anAssignmentNode needsParenthesis
		ifTrue: [ writer nextPut: $) ]! !

!XeTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 5/27/2012 23:13'!
acceptBlockNode: aBlockNode
	writer incrementIndentation.
	writer
		nextPut: ${;
		cr.
	self visitArguments: aBlockNode arguments.
	aBlockNode isConditionalBlock
		ifTrue: [ 
			| lastStmt |
			lastStmt := aBlockNode body statements removeLast.
			self visitNode: aBlockNode body.
			writer nextPutAll: 'if ('.
			aBlockNode isTrueBlock
				ifTrue: [ 
					writer nextPutAll: '!!('.
					self visitNode: lastStmt.
					writer nextPut: $) ]
				ifFalse: [ self visitNode: lastStmt ].
			writer
				nextPutAll: ') break;';
				cr ]
		ifFalse: [ self visitNode: aBlockNode body ].
	writer nextPut: $}.
	writer decrementIndentation! !

!XeTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 6/16/2012 19:42'!
acceptLiteralNode: aLiteralNode
	writer nextPutAll: (aLiteralNode token value asCLiteralValueFor: cg)! !

!XeTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 6/18/2012 23:23'!
acceptMessageNode: aMessageNode
	"(aMessageNode isCascaded not or: [ aMessageNode isFirstCascaded ])
		ifTrue: [ self visitNode: aMessageNode receiver ]."

	aMessageNode needsParenthesis
		ifTrue: [ writer nextPut: $( ].
	(self translateBuiltinMessageFor: aMessageNode)
		ifFalse: [ 
			aMessageNode isUnary ifTrue: [
				writer nextPutAll: aMessageNode cFunctionName.
				writer nextPutAll: '()'.
				].
			aMessageNode isBinary
				ifTrue: [ 
					self visitNode: aMessageNode receiver.
					aMessageNode emitSelectorOn: writer.
					self visitArguments: aMessageNode arguments ].
			aMessageNode isKeyword
				ifTrue: [ 
					writer nextPutAll: aMessageNode cFunctionName.
					writer nextPut: $(.
					aMessageNode arguments do: [ :each | self visitNode: each ] separatedBy: [ writer nextPutAll: ', ' ].
					writer nextPut: $) ] ].
	aMessageNode needsParenthesis
		ifTrue: [ writer nextPut: $) ].
	^ self! !

!XeTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 6/18/2012 21:49'!
acceptMethodNode: aMethodNode
	aMethodNode shouldTranslate
		ifTrue: [ 
			aMethodNode emitDeclarationOn: writer.
			writer
				nextPut: ${;
				cr.
			writer incrementIndentation.
			aMethodNode returnType = #void asXeType
				ifTrue: [ aMethodNode addReturn ].
			self visitNode: aMethodNode body.
			writer decrementIndentation.
			writer
				nextPut: $};
				cr ]! !

!XeTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 6/16/2012 15:15'!
acceptReturnNode: aReturnNode
	aReturnNode xeScope returnType = #void asXeType
		ifTrue: [ 
			self visitNode: aReturnNode value.
			writer endsWithClosingBracket
				ifFalse: [ writer nextPut: $; ].
			writer cr.
			writer nextPutAll: 'return' ]
		ifFalse: [ 
			writer
				nextPutAll: 'return';
				space.
			self visitNode: aReturnNode value ]! !

!XeTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 6/3/2012 16:22'!
acceptSequenceNode: aSequenceNode
	self visitTemporaries: aSequenceNode temporaries.
	aSequenceNode statements
		do: [ :each | 
			self visitNode: each.
			writer endsWithClosingBracket
				ifFalse: [ writer nextPut: $; ].
			writer cr ]! !

!XeTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 5/27/2012 23:13'!
acceptVariableNode: aVariableNode
	aVariableNode xeVariableBinding isSelfBinding
		ifFalse: [ writer nextPutAll: aVariableNode name ]! !

!XeTranslator methodsFor: 'accessing' stamp: 'BernardoContreras 6/16/2012 19:37'!
cg: aCodeGenerator 
	cg := aCodeGenerator 
	! !

!XeTranslator methodsFor: 'initialize-release' stamp: 'BernardoContreras 5/27/2012 23:13'!
initialize
	super initialize.
	self initializeTranslationDictionary! !

!XeTranslator methodsFor: 'initialize-release' stamp: 'BernardoContreras 6/14/2012 20:23'!
initializeTranslationDictionary
	translationDict := Dictionary new: 100.
	translationDict at: #ifTrue: put: #translateIfTrueFor:.
	translationDict at: #ifTrue:ifFalse: put: #translateIfTrueIfFalseFor:.
	translationDict at: #ifFalse: put: #translateIfFalseFor:.
	translationDict at: #ifFalse:ifTrue: put: #translateIfFalseIfTrueFor:.
	translationDict at: #whileTrue: put: #translateWhileTrueDoFor:.
	translationDict at: #doWhileTrue: put: #translateDoWhileTrueFor:.
	translationDict at: #whileTrue put: #translateWhileTrueFor:.
	translationDict at: #whileFalse: put: #translateWhileFalseDoFor:.
	translationDict at: #doWhileFalse: put: #translateDoWhileFalseFor:.
	translationDict at: #whileFalse put: #translateWhileFalseFor:.
	translationDict at: #= put: #translateEqualFor:.
	translationDict at: #~~ put: #translateNotEqualFor:.
	translationDict at: #~= put: #translateNotEqualFor:.
	translationDict at: #not put: #translateNotFor:.
	translationDict at: #& put: #translateAndFor:.
	translationDict at: #| put: #translateOrFor:.
	translationDict at: #\\ put: #translateModuloFor:.
	translationDict at: #negated put: #translateNegatedFor:! !

!XeTranslator methodsFor: 'public' stamp: 'BernardoContreras 4/7/2012 02:36'!
translate: methods
	self translateFunctionPrototypesFor: methods.
	self translateMethodsFor: methods! !

!XeTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 6/9/2012 18:20'!
translateAndFor: aMessageNode
	self visitNode: aMessageNode receiver.
	writer nextPutAll: ' && '.
	self visitArguments: aMessageNode arguments! !

!XeTranslator methodsFor: 'private' stamp: 'BernardoContreras 5/27/2012 23:13'!
translateBuiltinMessageFor: aMessageNode
	"If the given selector is in the translation dictionary, translate it into a target code construct and return true. Otherwise, do nothing and return false."

	| action |
	action := translationDict at: aMessageNode selector ifAbsent: [ ^ false ].
	self perform: action with: aMessageNode.
	^ true! !

!XeTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 5/27/2012 23:13'!
translateDoWhileFalseFor: aMessageNode
	writer nextPutAll: 'do '.
	aMessageNode arguments first beFalseBlock.
	aMessageNode receiver addLastStmt: aMessageNode arguments first.
	self visitArguments: aMessageNode receiver.
	writer nextPutAll: ' while (1)'! !

!XeTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 5/27/2012 23:13'!
translateDoWhileTrueFor: aMessageNode
	writer nextPutAll: 'do '.
	aMessageNode arguments first beTrueBlock.
	aMessageNode receiver addLastStmt: aMessageNode arguments first.
	self visitArguments: aMessageNode receiver.
	writer nextPutAll: ' while (1)'! !

!XeTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 6/8/2012 22:01'!
translateEqualFor: aMessageNode
	self visitNode: aMessageNode receiver.
	writer nextPutAll: ' == '.
	self visitArguments: aMessageNode arguments! !

!XeTranslator methodsFor: 'private' stamp: 'BernardoContreras 6/18/2012 21:49'!
translateFunctionPrototypesFor: methods
	writer functionPrototypesComment.
	methods do: [ :each | each emitFunctionPrototypeOn: writer ]! !

!XeTranslator methodsFor: 'public' stamp: 'BernardoContreras 6/20/2012 02:18'!
translateHeaderFiles: aSetOfHeaderFiles
	aSetOfHeaderFiles
		do: [ :each | 
			writer nextPutAll: '#include '.
			writer nextPutAll: each.
			writer cr ]! !

!XeTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 5/27/2012 23:13'!
translateIfFalseFor: aMessageNode
	aMessageNode parent isSequence
		ifTrue: [ 
			writer nextPutAll: 'if (!!('.
			self visitNode: aMessageNode receiver.
			writer nextPutAll: ')) '.
			self visitArguments: aMessageNode arguments ]
		ifFalse: [ 
			writer nextPutAll: '(!!('.
			self visitNode: aMessageNode receiver.
			writer nextPutAll: ') ? '.
			self visitArguments: aMessageNode arguments first lastStmt.
			writer nextPutAll: ' : 0)' ]! !

!XeTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 5/27/2012 23:13'!
translateIfFalseIfTrueFor: aMessageNode
	writer nextPutAll: 'if (!!('.
	self visitNode: aMessageNode receiver.
	writer nextPutAll: ')) '.
	self visitArguments: aMessageNode arguments first.
	writer nextPutAll: ' else '.
	self visitArguments: aMessageNode arguments second! !

!XeTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 5/27/2012 23:13'!
translateIfTrueFor: aMessageNode
	aMessageNode parent isSequence
		ifTrue: [ 
			writer nextPutAll: 'if ('.
			self visitNode: aMessageNode receiver.
			writer nextPutAll: ') '.
			self visitArguments: aMessageNode arguments ]
		ifFalse: [ 
			writer nextPutAll: '('.
			self visitNode: aMessageNode receiver.
			writer nextPutAll: ' ? '.
			self visitArguments: aMessageNode arguments first lastStmt.
			writer nextPutAll: ' : 0)' ]! !

!XeTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 5/27/2012 23:13'!
translateIfTrueIfFalseFor: aMessageNode
	writer nextPutAll: 'if ('.
	self visitNode: aMessageNode receiver.
	writer nextPutAll: ') '.
	self visitArguments: aMessageNode arguments first.
	writer nextPutAll: ' else '.
	self visitArguments: aMessageNode arguments second! !

!XeTranslator methodsFor: 'private' stamp: 'BernardoContreras 5/27/2012 23:15'!
translateMethodsFor: methods
	methods do: [ :each | self visitNode: each ]! !

!XeTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 6/13/2012 00:18'!
translateModuloFor: aMessageNode
	self visitNode: aMessageNode receiver.
	writer nextPutAll: ' % '.
	self visitArguments: aMessageNode arguments! !

!XeTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 6/14/2012 20:25'!
translateNegatedFor: aMessageNode 
	writer nextPut: $-.
	self visitNode: aMessageNode receiver! !

!XeTranslator methodsFor: 'public' stamp: 'BernardoContreras 6/9/2012 00:21'!
translateNode: aNode
	self visitNode: aNode! !

!XeTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 6/9/2012 00:55'!
translateNotEqualFor: aMessageNode 
	self visitNode: aMessageNode receiver.
	writer nextPutAll: ' !!= '.
	self visitArguments: aMessageNode arguments! !

!XeTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 6/9/2012 18:51'!
translateNotFor: aMessageNode
	writer nextPutAll: '!!('.
	self visitNode: aMessageNode receiver.
	writer nextPut: $)! !

!XeTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 6/9/2012 18:17'!
translateOrFor: aMessageNode
	self visitNode: aMessageNode receiver.
	writer nextPutAll: ' || '.
	self visitArguments: aMessageNode arguments! !

!XeTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 5/27/2012 23:13'!
translateWhileFalseDoFor: aMessageNode
	writer nextPutAll: 'while (1) '.
	aMessageNode receiver beFalseBlock.
	aMessageNode arguments first addFirstStmt: aMessageNode receiver.
	self visitArguments: aMessageNode arguments! !

!XeTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 5/27/2012 23:13'!
translateWhileFalseFor: aMessageNode
	writer nextPutAll: 'while (1) '.
	aMessageNode receiver beFalseBlock.
	self visitNode: aMessageNode receiver! !

!XeTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 5/27/2012 23:13'!
translateWhileTrueDoFor: aMessageNode
	writer nextPutAll: 'while (1) '.
	aMessageNode receiver beTrueBlock.
	aMessageNode arguments first addFirstStmt: aMessageNode receiver.
	self visitArguments: aMessageNode arguments! !

!XeTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 5/27/2012 23:13'!
translateWhileTrueFor: aMessageNode
	writer nextPutAll: 'while (1) '.
	aMessageNode receiver beTrueBlock.
	self visitNode: aMessageNode receiver! !

!XeTranslator methodsFor: 'visiting' stamp: 'BernardoContreras 6/8/2012 22:27'!
visitTemporaries: temporaries
	temporaries
		do: [ :each | 
			each emitDeclarationOn: writer.
			writer endOfStatement ]! !

!XeTranslator methodsFor: 'accessing' stamp: 'BernardoContreras 5/27/2012 17:49'!
writer: aWriter
	writer := aWriter! !

!RBPragmaNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/18/2012 21:06'!
isDoNotTranslate
	"return true if it is doNotTranslate pragma"

	^ self selector == #doNotTranslate! !

!RBPragmaNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/19/2012 22:42'!
isNoFunctionPrototype
	"return true if it is noFunctionPrototype pragma"

	^ self selector == #noFunctionPrototype
	! !

!RBPragmaNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/13/2012 03:36'!
isReturnType
	"return true if it is returnType: pragma"

	^ self selector == #returnType:! !

!RBPragmaNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/13/2012 02:49'!
isVarType
	"return true if it is var:type: pragma"

	^ self selector == #var:type:! !

!RBPragmaNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/25/2012 16:03'!
returnType
	^ self arguments first value
	! !

!RBPragmaNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/25/2012 16:03'!
varName
	^ self arguments first value! !

!RBPragmaNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/25/2012 16:03'!
varType
	^ self arguments second value asXeType! !

!RBSequenceNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/20/2012 17:13'!
addFirstStmt: aStmt
	^ self statements addFirst: aStmt! !

!RBSequenceNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/20/2012 17:14'!
addLastStmt: aStmt
	^ self statements addLast: aStmt! !

!RBSequenceNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/20/2012 17:14'!
lastStmt
	^ statements last! !

!True methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/16/2012 19:45'!
asCLiteralValueFor: cg
	^ '1'! !

!RBMessageNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/9/2012 03:59'!
cFunctionName
	"Create a C function name from the given selector by omitting colons"
	^ self selector copyWithout: $:! !

!RBMessageNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/8/2012 22:21'!
emitSelectorOn: writer
	writer space.
	writer nextPutAll: self selector.
	writer space! !

!RBBlockNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/20/2012 16:59'!
addFirstStmt: aStmt
	^ self body addFirstStmt: aStmt! !

!RBBlockNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/20/2012 17:13'!
addLastStmt: aStmt
	^ self body addLastStmt: aStmt! !

!RBBlockNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/30/2012 23:48'!
beFalseBlock
	self propertyAt: #xeConditionalBlock put: #FalseBlock! !

!RBBlockNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/30/2012 21:28'!
beTrueBlock
	self propertyAt: #xeConditionalBlock put: #TrueBlock! !

!RBBlockNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/30/2012 21:16'!
isConditionalBlock
	^ self hasProperty: #xeConditionalBlock! !

!RBBlockNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/30/2012 21:27'!
isTrueBlock
	^ (self propertyAt: #xeConditionalBlock) == #TrueBlock! !

!RBBlockNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/16/2012 22:43'!
lastStmt
	^ self body lastStmt.! !

!False methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/16/2012 19:45'!
asCLiteralValueFor: cg
	^ '0'! !

!RBVariableNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/27/2012 17:12'!
emitDeclarationOn: writer 
	self type emitOn: writer.
	writer space .
	writer nextPutAll: self name! !

!RBVariableNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/25/2012 16:56'!
hasXeVariableBinding
	^ self hasProperty: #xeVariableBinding! !

!RBVariableNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/16/2012 15:43'!
type
	| binding |
	binding := self xeScope lookup: self name , '-type' ifAbsent: [ self xeVariableBinding ].
	^ binding type! !

!RBVariableNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/15/2012 01:51'!
xeVariableBinding
	^ self propertyAt: #xeVariableBinding ifAbsent: [ self xeSemanticAnnotationMissing ]! !

!RBVariableNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/16/2012 17:32'!
xeVariableBinding: binding 
	self propertyAt: #xeVariableBinding put: binding! !

Error subclass: #XeSemanticAnnotationMissing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Exceptions'!

!XeSemanticAnnotationMissing commentStamp: 'BernardoContreras 5/12/2012 23:02' prior: 0!
stolen from AST-Semantic!

!XeSemanticAnnotationMissing methodsFor: 'private' stamp: 'BernardoContreras 4/14/2012 21:13'!
isResumable
	^ true! !

!UndefinedObject methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/16/2012 19:47'!
asCLiteralValueFor: cg
	^ 'null'
	! !

!LargePositiveInteger methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/16/2012 19:52'!
asCLiteralValueFor: cg
	^ self printString, cg unsignedIntegerSuffix ! !

!Character methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/16/2012 19:44'!
asCLiteralValueFor: cg
	^ '''' , self asString , ''''! !

!Number methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/16/2012 19:47'!
asCLiteralValueFor: cg
	^ self printString ! !

!RBProgramNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/16/2012 18:12'!
xeAnnotateInClass: aBehavior with: cg 
	XeSemanticAnnotator new cg: cg;
		start: self
		scope: (XeVariableScope owner: (XeLiteralScope owner: XeRootScope new class: aBehavior) class: aBehavior)! !

!RBProgramNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/16/2012 15:23'!
xeScope
	^ self propertyAt: #xeScope ifAbsent: [ 
		self parent isNil
			ifFalse: [ self parent xeScope ]
			ifTrue: [ self xeSemanticAnnotationMissing ] ]! !

!RBProgramNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/16/2012 15:11'!
xeScope: aScope 
	self propertyAt: #xeScope put: aScope 
	! !

!RBProgramNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/15/2012 02:47'!
xeSemanticAnnotationMissing
	XeSemanticAnnotationMissing signal: 'Semantic annotation missing, please use #xeAnnotateInClass: to annotate the AST'! !

!Object methodsFor: '*xenon-core' stamp: 'BernardoContreras 6/16/2012 19:43'!
asCLiteralValueFor: cg 
	self subclassResponsibility! !

Object subclass: #XeBytesPerWord
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Platform'!

!XeBytesPerWord commentStamp: '<historical>' prior: 0!
Bytes Per Word.
Stereotype: DataHolder.
knows how many bytes per word. i.e. knows word size.

Instance Variables
	size: number of bytes per word.
	

!

!XeBytesPerWord class methodsFor: 'instance creation' stamp: 'BernardoContreras 6/16/2012 20:16'!
eightBytesPerWord 
 ^ XeEightBytesPerWord new! !

!XeBytesPerWord class methodsFor: 'instance creation' stamp: 'BernardoContreras 6/16/2012 20:15'!
fourBytesPerWord 
 ^ XeFourBytesPerWord new! !

!XeBytesPerWord methodsFor: 'printing' stamp: 'BernardoContreras 5/15/2011 17:41'!
printOn: aStream
	"Append to the argument, aStream, a sequence of characters that  
	identifies the receiver."

	aStream
		nextPutAll: size asString;
		nextPutAll: ' bytes per word'! !

!XeBytesPerWord methodsFor: 'accessing' stamp: 'BernardoContreras 6/16/2012 20:20'!
signedIntegerSuffix
	"Answer the suffix that should be appended to signed integer literals in generated code."
	self subclassResponsibility 
	
! !

!XeBytesPerWord methodsFor: 'accessing' stamp: 'bec 12/1/2009 14:34'!
size
	"how many bytes per word?"
	^ size! !

!XeBytesPerWord methodsFor: 'accessing' stamp: 'BernardoContreras 6/16/2012 23:05'!
unsignedIntegerSuffix
	"Answer the suffix that should be appended to unsigned integer literals in generated code."
	
	self subclassResponsibility 
	
! !

XeBytesPerWord subclass: #XeEightBytesPerWord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Platform'!

!XeEightBytesPerWord commentStamp: '<historical>' prior: 0!
eight bytes per word

!

!XeEightBytesPerWord methodsFor: 'initialize-release' stamp: 'BernardoContreras 6/16/2012 20:17'!
initialize
	size := 8
	! !

!XeEightBytesPerWord methodsFor: 'accessing' stamp: 'BernardoContreras 6/16/2012 23:05'!
unsignedIntegerSuffix
	^ 'ULL'! !

XeBytesPerWord subclass: #XeFourBytesPerWord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Platform'!

!XeFourBytesPerWord commentStamp: '<historical>' prior: 0!
four bytes per word

!

!XeFourBytesPerWord methodsFor: 'initialize-release' stamp: 'BernardoContreras 6/16/2012 20:17'!
initialize
	size := 4! !

!XeFourBytesPerWord methodsFor: 'accessing' stamp: 'BernardoContreras 6/16/2012 23:05'!
unsignedIntegerSuffix
	^ 'UL'! !

Object subclass: #XeCodeGenerator
	instanceVariableNames: 'methods eightBytesPerWord fourBytesPerWord bytesPerWord defaultType defaultReturnType headerFiles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core'!

!XeCodeGenerator commentStamp: '<historical>' prior: 0!
To generate C code from a reduced Smalltalk code.

* Constants are translated only if they are binded in a method.
!

!XeCodeGenerator methodsFor: 'public' stamp: 'BernardoContreras 6/20/2012 02:14'!
addClass: aClass
	(aClass class traitCompositionIncludes: XeDefineOnCG)
		ifTrue: [ aClass defineOn: self ].
	aClass methodsDo: [ :method | methods add: (self annotateMethod: method inClass: aClass) ]! !

!XeCodeGenerator methodsFor: 'public' stamp: 'BernardoContreras 6/20/2012 00:45'!
addHeaderFile: aString	
	"Add a header file. The argument must be a quoted string!!"
	headerFiles add: aString.! !

!XeCodeGenerator methodsFor: 'private' stamp: 'BernardoContreras 6/16/2012 18:08'!
annotateExpression: aString inClass: aClass
	"annotate a string in a class"

	^ (self parseExpression: aString) xeAnnotateInClass: aClass with: self.! !

!XeCodeGenerator methodsFor: 'private' stamp: 'BernardoContreras 6/16/2012 18:08'!
annotateMethod: method inClass: aClass
	"annotate a method in a class"

	^ method parseTree xeAnnotateInClass: aClass with: self.! !

!XeCodeGenerator methodsFor: 'accessing' stamp: 'BernardoContreras 6/16/2012 23:04'!
beEightBytesPerWord
	bytesPerWord := eightBytesPerWord ! !

!XeCodeGenerator methodsFor: 'public' stamp: 'BernardoContreras 6/18/2012 23:26'!
codeString
	| stream |
	stream := ReadWriteStream on: (String new: 1000).
	self translateOn: stream.
	^ stream contents! !

!XeCodeGenerator methodsFor: 'private' stamp: 'BernardoContreras 6/16/2012 19:36'!
createTranslatorFor: aStream
	| writer |
	writer := XeWriter newFor: aStream.
	^ XeTranslator newFor: writer and: self.! !

!XeCodeGenerator methodsFor: 'accessing' stamp: 'BernardoContreras 6/16/2012 18:35'!
defaultReturnType
	^ defaultReturnType! !

!XeCodeGenerator methodsFor: 'accessing' stamp: 'BernardoContreras 6/16/2012 18:17'!
defaultType
	^ defaultType! !

!XeCodeGenerator methodsFor: 'initialize-release' stamp: 'BernardoContreras 6/20/2012 00:45'!
initialize
	super initialize.
	fourBytesPerWord := XeBytesPerWord fourBytesPerWord.
	eightBytesPerWord := XeBytesPerWord eightBytesPerWord.
	bytesPerWord := fourBytesPerWord. 
	defaultType := #void asXeType.
	defaultReturnType := #int asXeType.
	methods := OrderedCollection new.
	headerFiles := Set new! !

!XeCodeGenerator methodsFor: 'private' stamp: 'BernardoContreras 6/9/2012 01:00'!
parseExpression: aString
	"return the tree node for the given string"

	^ RBParser parseExpression: aString! !

!XeCodeGenerator methodsFor: 'private' stamp: 'BernardoContreras 4/14/2012 06:58'!
sortMethods
	methods sort: [ :a :b | a selector caseSensitiveLessOrEqual: b selector ]! !

!XeCodeGenerator methodsFor: 'testing' stamp: 'BernardoContreras 6/18/2012 23:33'!
translateExpression: aString in: aClass
	| stream node |
	stream := ReadWriteStream on: (String new: 1000).
	node := self annotateExpression: aString inClass: aClass.
	self translateNode: node on: stream.
	^ stream contents! !

!XeCodeGenerator methodsFor: 'testing' stamp: 'BernardoContreras 6/18/2012 23:33'!
translateNode: aNode on: aStream
	| translator |
	translator := self createTranslatorFor: aStream.
	translator translateNode: aNode.
! !

!XeCodeGenerator methodsFor: 'public' stamp: 'BernardoContreras 6/20/2012 02:16'!
translateOn: aWriteStream 
	| translator |
	translator := self createTranslatorFor: aWriteStream.
	self sortMethods.
	translator translateHeaderFiles: headerFiles.
	translator translate: methods.
! !

!XeCodeGenerator methodsFor: 'accessing' stamp: 'BernardoContreras 6/16/2012 19:52'!
unsignedIntegerSuffix
	^ bytesPerWord unsignedIntegerSuffix! !

Object subclass: #XeLexicalScope
	instanceVariableNames: 'bindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeLexicalScope commentStamp: 'BernardoContreras 5/12/2012 22:59' prior: 0!
stolen from AST-Semantic!

!XeLexicalScope class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:27'!
new
	^ self basicNew initialize! !

!XeLexicalScope methodsFor: 'adding' stamp: 'BernardoContreras 4/15/2012 02:48'!
add: aVariableBinding
	"Add aVariableBinding to the receiving scope."

	^ bindings at: aVariableBinding name put: (aVariableBinding setScope: self)! !

!XeLexicalScope methodsFor: 'private' stamp: 'BernardoContreras 4/14/2012 20:27'!
basicBindingOf: aString
	^ nil! !

!XeLexicalScope methodsFor: 'binding' stamp: 'BernardoContreras 4/14/2012 20:27'!
bindingOf: aString
	"Answer the local binding of aString or nil."
	
	^ bindings at: aString ifAbsent: [
		| binding |
		binding := (self basicBindingOf: aString) 
			ifNil: [ ^ nil ].
		self add: binding ]! !

!XeLexicalScope methodsFor: 'initialize-release' stamp: 'BernardoContreras 4/30/2012 21:05'!
initialize
	bindings := RBSmallDictionary new! !

!XeLexicalScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:27'!
isBlockScope
	^ false! !

!XeLexicalScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:27'!
isLiteralScope
	^ false! !

!XeLexicalScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:27'!
isMethodScope
	^ false! !

!XeLexicalScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:27'!
isRootScope
	^ false! !

!XeLexicalScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:27'!
isVariableScope
	^ false! !

!XeLexicalScope methodsFor: 'querying' stamp: 'BernardoContreras 4/14/2012 20:27'!
lookup: aString
	"Lookup the variable aString in the receiving scope, throw an error if not found."

	^ self lookup: aString ifAbsent: [ self error: 'No binding for ' , aString printString , ' found.' ]! !

!XeLexicalScope methodsFor: 'querying' stamp: 'BernardoContreras 4/14/2012 20:27'!
lookup: aString ifAbsent: aBlock
	"Lookup the variable aString in the receiving scope, evaluate aBlock if not found."

	self subclassResponsibility! !

XeLexicalScope subclass: #XeOwnedScope
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeOwnedScope commentStamp: 'BernardoContreras 5/12/2012 23:00' prior: 0!
stolen from AST-Semantic!

XeOwnedScope subclass: #XeClassScope
	instanceVariableNames: 'class'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeClassScope commentStamp: 'BernardoContreras 5/12/2012 23:00' prior: 0!
stolen from AST-Semantic!

!XeClassScope class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:30'!
owner: aLexicalScope class: aBehavior
	^ (self owner: aLexicalScope) setClass: aBehavior! !

!XeClassScope methodsFor: 'initialization' stamp: 'BernardoContreras 4/14/2012 20:30'!
setClass: aBehavior
	class := aBehavior! !

!XeClassScope methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:30'!
theClass
	^ class! !

XeClassScope subclass: #XeLiteralScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeLiteralScope commentStamp: 'BernardoContreras 5/12/2012 23:00' prior: 0!
stolen from AST-Semantic!

!XeLiteralScope methodsFor: 'private' stamp: 'BernardoContreras 4/14/2012 21:10'!
basicBindingOf: aString
	^ (class bindingOf: aString) ifNotNil: [ :binding | XeLiteralBinding binding: binding ]! !

!XeLiteralScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:31'!
isLiteralScope
	^ true! !

XeClassScope subclass: #XeVariableScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeVariableScope commentStamp: 'BernardoContreras 5/12/2012 23:00' prior: 0!
stolen from AST-Semantic!

!XeVariableScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:37'!
isVariableScope
	^ true! !

!XeVariableScope methodsFor: 'initialization' stamp: 'BernardoContreras 4/14/2012 21:11'!
setClass: aClass
	super setClass: aClass.
	aClass allInstVarNames 
		keysAndValuesDo: [ :index :name | self add: (XeInstanceBinding name: name index: index) ]! !

XeOwnedScope subclass: #XeNodedScope
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeNodedScope commentStamp: 'BernardoContreras 5/12/2012 23:00' prior: 0!
stolen from AST-Semantic!

XeNodedScope subclass: #XeBlockScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeBlockScope commentStamp: 'BernardoContreras 5/12/2012 23:00' prior: 0!
stolen from AST-Semantic!

!XeBlockScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:39'!
isBlockScope
	^ true! !

XeNodedScope subclass: #XeMethodScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeMethodScope commentStamp: 'BernardoContreras 5/12/2012 23:00' prior: 0!
stolen from AST-Semantic!

!XeMethodScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:40'!
isMethodScope
	^ true! !

!XeNodedScope class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:38'!
owner: aLexicalScope node: aProgramNode
	^ (self owner: aLexicalScope) setNode: aProgramNode! !

!XeNodedScope methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:38'!
node
	"Answer the program node that defines this scope."
	
	^ node! !

!XeNodedScope methodsFor: 'accessing' stamp: 'BernardoContreras 6/18/2012 22:14'!
returnType
	^ (self lookup: 'returnType' ifAbsent: [ node defaultReturnType ]) asXeType! !

!XeNodedScope methodsFor: 'initialization' stamp: 'BernardoContreras 6/16/2012 15:11'!
setNode: aProgramNode
	node := aProgramNode.
	node xeScope: self! !

!XeOwnedScope class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:28'!
owner: aLexicalScope
	^ self new setOwner: aLexicalScope! !

!XeOwnedScope methodsFor: 'querying' stamp: 'BernardoContreras 4/14/2012 20:28'!
lookup: aString ifAbsent: aBlock
	^ (self bindingOf: aString) ifNil: [ owner lookup: aString ifAbsent: aBlock ]! !

!XeOwnedScope methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:28'!
owner
	"Answer the owning scope."

	^ owner! !

!XeOwnedScope methodsFor: 'initialization' stamp: 'BernardoContreras 4/14/2012 20:28'!
setOwner: aLexicalScope
	owner := aLexicalScope! !

XeLexicalScope subclass: #XeRootScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeRootScope commentStamp: 'BernardoContreras 5/12/2012 23:00' prior: 0!
stolen from AST-Semantic!

!XeRootScope methodsFor: 'initialize-release' stamp: 'BernardoContreras 4/14/2012 21:11'!
initialize
	super initialize.
	self add: XeSelfBinding new.
	self add: XeSuperBinding new.
	self add: XeContextBinding new! !

!XeRootScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:42'!
isRootScope
	^ true! !

!XeRootScope methodsFor: 'querying' stamp: 'BernardoContreras 4/14/2012 20:42'!
lookup: aString ifAbsent: aBlock
	^ bindings at: aString ifAbsent: aBlock! !

Object subclass: #XeType
	instanceVariableNames: 'typename'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Types'!

!XeType commentStamp: 'BernardoContreras 2/27/2012 19:07' prior: 0!
To describe types!

!XeType class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/22/2012 01:39'!
name: aString 
	^ self new typename: aString.! !

!XeType methodsFor: 'comparing' stamp: 'BernardoContreras 4/22/2012 01:38'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ typename = anObject typename! !

!XeType methodsFor: 'converting' stamp: 'BernardoContreras 6/16/2012 18:42'!
asXeType
	^ self! !

!XeType methodsFor: 'emit code' stamp: 'BernardoContreras 5/27/2012 00:38'!
emitOn: cg
	"emit the string representation of this type on a code generator"

	cg nextPutAll: typename! !

!XeType methodsFor: 'comparing' stamp: 'BernardoContreras 4/22/2012 01:38'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ typename hash! !

!XeType methodsFor: 'printing' stamp: 'BernardoContreras 4/22/2012 01:38'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPutAll: ' named: ';
		nextPutAll: typename! !

!XeType methodsFor: 'accessing' stamp: 'BernardoContreras 4/22/2012 01:38'!
typename
	^ typename! !

!XeType methodsFor: 'accessing' stamp: 'BernardoContreras 4/22/2012 01:39'!
typename: aString 
	typename := aString! !

Object subclass: #XeVariableBinding
	instanceVariableNames: 'scope accessors readers writers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeVariableBinding commentStamp: 'BernardoContreras 5/12/2012 23:00' prior: 0!
stolen from AST-Semantic!

XeVariableBinding subclass: #XeInstanceBinding
	instanceVariableNames: 'name index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeInstanceBinding commentStamp: 'BernardoContreras 5/12/2012 23:01' prior: 0!
stolen from AST-Semantic!

!XeInstanceBinding class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:54'!
name: aString index: anInteger
	^ self new initializeName: aString index: anInteger! !

!XeInstanceBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:54'!
index
	^ index! !

!XeInstanceBinding methodsFor: 'initialization' stamp: 'BernardoContreras 4/14/2012 20:54'!
initializeName: aString index: anInteger
	name := aString.
	index := anInteger! !

!XeInstanceBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:54'!
isInstanceBinding
	^ true! !

!XeInstanceBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:54'!
name
	^ name! !

XeVariableBinding subclass: #XeLiteralBinding
	instanceVariableNames: 'binding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeLiteralBinding commentStamp: 'BernardoContreras 5/12/2012 23:01' prior: 0!
stolen from AST-Semantic!

!XeLiteralBinding class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:55'!
binding: aBinding
	^ self new initializeBinding: aBinding! !

!XeLiteralBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:55'!
binding
	^ binding! !

!XeLiteralBinding methodsFor: 'initialization' stamp: 'BernardoContreras 4/14/2012 20:55'!
initializeBinding: aBinding
	binding := aBinding! !

!XeLiteralBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:55'!
isLiteralBinding
	^ true! !

!XeLiteralBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:55'!
name
	^ binding key asString! !

XeVariableBinding subclass: #XeLocalBinding
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeLocalBinding commentStamp: 'BernardoContreras 5/12/2012 23:01' prior: 0!
stolen from AST-Semantic!

XeLocalBinding subclass: #XeArgumentBinding
	instanceVariableNames: 'type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeArgumentBinding commentStamp: 'BernardoContreras 5/12/2012 23:01' prior: 0!
stolen from AST-Semantic!

!XeArgumentBinding class methodsFor: 'instance-creation' stamp: 'BernardoContreras 6/8/2012 09:50'!
node: aNode type: aType
	^ self new
		setNode: aNode;
		type: aType;
		yourself! !

!XeArgumentBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:57'!
isArgumentBinding
	^ true! !

!XeArgumentBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:57'!
isReadonly
	^ true! !

!XeArgumentBinding methodsFor: 'accessing' stamp: 'BernardoContreras 6/7/2012 22:26'!
type
	^ type! !

!XeArgumentBinding methodsFor: 'accessing' stamp: 'BernardoContreras 6/7/2012 22:26'!
type: aType 
	type := aType ! !

!XeLocalBinding class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:56'!
node: aNode
	^ self new setNode: aNode! !

!XeLocalBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:56'!
name
	^ node name! !

!XeLocalBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:56'!
node
	"Answer the declaring or defining node."
	
	^ node! !

!XeLocalBinding methodsFor: 'initialization' stamp: 'BernardoContreras 6/16/2012 17:31'!
setNode: aNode
	node := aNode.
	node xeVariableBinding: self! !

XeLocalBinding subclass: #XeTemporaryBinding
	instanceVariableNames: 'type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeTemporaryBinding commentStamp: 'BernardoContreras 5/12/2012 23:01' prior: 0!
stolen from AST-Semantic!

!XeTemporaryBinding class methodsFor: 'instance-creation' stamp: 'BernardoContreras 6/8/2012 09:50'!
node: aNode type: aType
	^ self new
		setNode: aNode;
		type: aType;
		yourself! !

!XeTemporaryBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:57'!
isTemporaryBinding
	^ true! !

!XeTemporaryBinding methodsFor: 'accessing' stamp: 'BernardoContreras 6/7/2012 22:26'!
type
	^ type! !

!XeTemporaryBinding methodsFor: 'accessing' stamp: 'BernardoContreras 6/7/2012 22:25'!
type: aType 
	type := aType ! !

XeLocalBinding subclass: #XeUndeclaredBinding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeUndeclaredBinding commentStamp: 'BernardoContreras 5/12/2012 23:01' prior: 0!
stolen from AST-Semantic!

!XeUndeclaredBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 21:01'!
isUndeclaredBinding
	^ true! !

XeVariableBinding subclass: #XeReturnTypeBinding
	instanceVariableNames: 'returnType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeReturnTypeBinding commentStamp: 'BernardoContreras 4/14/2012 20:49' prior: 0!
To bind the return type of  a method
!

!XeReturnTypeBinding class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/13/2012 01:23'!
returnType: typeName
	^ self new
		returnType: typeName;
		yourself! !

!XeReturnTypeBinding methodsFor: 'converting' stamp: 'BernardoContreras 4/13/2012 02:27'!
asXeType
	^ returnType asXeType
	! !

!XeReturnTypeBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/13/2012 02:12'!
name
	"Answer the name of the variable."

	^ 'returnType'! !

!XeReturnTypeBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/13/2012 01:24'!
returnType: typeName
 	returnType := typeName! !

XeVariableBinding subclass: #XeSpecialBinding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeSpecialBinding commentStamp: 'BernardoContreras 5/12/2012 23:01' prior: 0!
stolen from AST-Semantic!

XeSpecialBinding subclass: #XeContextBinding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeContextBinding commentStamp: 'BernardoContreras 5/12/2012 23:01' prior: 0!
stolen from AST-Semantic!

!XeContextBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 21:03'!
isContextBinding
	^ true! !

!XeContextBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 21:03'!
name
	^ 'thisContext'! !

XeSpecialBinding subclass: #XeSelfBinding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeSelfBinding commentStamp: 'BernardoContreras 5/12/2012 23:02' prior: 0!
stolen from AST-Semantic!

!XeSelfBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 21:03'!
isSelfBinding
	^ true! !

!XeSelfBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 21:03'!
name
	^ 'self'! !

!XeSpecialBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 21:02'!
isReadonly
	^ true! !

XeSpecialBinding subclass: #XeSuperBinding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeSuperBinding commentStamp: 'BernardoContreras 5/12/2012 23:02' prior: 0!
stolen from AST-Semantic!

!XeSuperBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 21:03'!
isSuperBinding
	^ true! !

!XeSuperBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 21:03'!
name
	^ 'super'! !

XeVariableBinding subclass: #XeVarTypeBinding
	instanceVariableNames: 'varName type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeVarTypeBinding commentStamp: 'BernardoContreras 6/8/2012 09:45' prior: 0!
To bind the type of  a variable
!

!XeVarTypeBinding class methodsFor: 'instance-creation' stamp: 'BernardoContreras 6/8/2012 09:49'!
varName: aVariableName type: aType
	^ self new
		varName: aVariableName;
		type: aType;
		yourself! !

!XeVarTypeBinding methodsFor: 'testing' stamp: 'BernardoContreras 6/8/2012 09:45'!
name
	"Answer the name of the variable."

	^ varName , '-type'! !

!XeVarTypeBinding methodsFor: 'accessing' stamp: 'BernardoContreras 6/8/2012 09:45'!
type
	^ type! !

!XeVarTypeBinding methodsFor: 'accessing' stamp: 'BernardoContreras 6/8/2012 09:45'!
type: aType
	type := aType! !

!XeVarTypeBinding methodsFor: 'accessing' stamp: 'BernardoContreras 6/8/2012 09:45'!
varName: aVariableName
	varName := aVariableName! !

!XeVariableBinding class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:49'!
new
	^ self basicNew initialize! !

!XeVariableBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:49'!
accessors
	"Answer the nodes that access the receiver."
	
	^ accessors! !

!XeVariableBinding methodsFor: 'protected' stamp: 'BernardoContreras 4/14/2012 20:49'!
addAccessor: aProgramNode
	accessors := accessors copyWith: aProgramNode! !

!XeVariableBinding methodsFor: 'protected' stamp: 'BernardoContreras 4/14/2012 20:49'!
addReader: aProgramNode
	readers := readers copyWith: aProgramNode! !

!XeVariableBinding methodsFor: 'protected' stamp: 'BernardoContreras 4/14/2012 20:49'!
addWriter: aProgramNode
	writers := writers copyWith: aProgramNode! !

!XeVariableBinding methodsFor: 'initialize-release' stamp: 'BernardoContreras 4/14/2012 20:49'!
initialize
	accessors := readers := writers := #()! !

!XeVariableBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:49'!
isAccessed
	"Answer true if the receiving binding is accessed."
	
	^ self accessors notEmpty! !

!XeVariableBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:49'!
isArgumentBinding
	^ false! !

!XeVariableBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:49'!
isContextBinding
	^ false! !

!XeVariableBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:49'!
isInstanceBinding
	^ false! !

!XeVariableBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:49'!
isLiteralBinding
	^ false! !

!XeVariableBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:49'!
isRead
	"Answer true if the receiving binding is read."
	
	^ self readers notEmpty! !

!XeVariableBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:49'!
isReadonly
	"Answer if the receiving binding is readonly."

	^ false! !

!XeVariableBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:49'!
isSelfBinding
	^ false! !

!XeVariableBinding methodsFor: 'testing' stamp: 'BernardoContreras 6/16/2012 15:32'!
isShadowing
	"Answer true if the receiving shadows another variable in a parent scope."

	self scope isRootScope
		ifTrue: [ ^ false ].
	self scope owner
		lookup: self name
		ifAbsent: [ ^ false ].
	^ true! !

!XeVariableBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:49'!
isSuperBinding
	^ false! !

!XeVariableBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:49'!
isTemporaryBinding
	^ false! !

!XeVariableBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:49'!
isUndeclaredBinding
	^ false! !

!XeVariableBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:49'!
isWritten
	"Answer true if the receiving binding is written."
	
	^ self writers notEmpty! !

!XeVariableBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:49'!
name
	"Answer the name of the variable."
	
	self subclassResponsibility! !

!XeVariableBinding methodsFor: 'printing' stamp: 'BernardoContreras 4/14/2012 20:49'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' name: '; print: self name! !

!XeVariableBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:49'!
readers
	"Answer the nodes that read from the receiver."
	
	^ readers! !

!XeVariableBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:49'!
scope
	"Answer the owning scope."
	
	^ scope! !

!XeVariableBinding methodsFor: 'initialize-release' stamp: 'BernardoContreras 4/14/2012 20:49'!
setScope: aLexicalScope
	scope := aLexicalScope! !

!XeVariableBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:49'!
writers
	"Answer the nodes that write to the receiver."
	
	^ writers! !

Object subclass: #XeWriter
	instanceVariableNames: 'stream indentationLevel beginningOfLine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Writer'!

!XeWriter commentStamp: '<historical>' prior: 0!
knows how to write on a stream

!

!XeWriter class methodsFor: 'instance creation' stamp: 'BernardoContreras 5/27/2012 17:48'!
newFor: aStream
	" a new instance for the given stream"

	^ self new
		stream: aStream;
		yourself! !

!XeWriter methodsFor: 'public writing' stamp: 'BernardoContreras 5/27/2012 17:47'!
cr
	stream cr.
	beginningOfLine := true! !

!XeWriter methodsFor: 'public writing' stamp: 'BernardoContreras 5/27/2012 17:47'!
decrementIndentation
	indentationLevel := indentationLevel - 1! !

!XeWriter methodsFor: 'public writing' stamp: 'BernardoContreras 5/27/2012 17:47'!
endOfStatement
	self nextPut: $;; cr! !

!XeWriter methodsFor: 'public writing' stamp: 'BernardoContreras 5/27/2012 17:47'!
endsWithClosingBracket
	"Answer true if the stream ends in a $} character."

	| ch pos |
	(pos := stream position) > 0
		ifTrue: [ 
			stream position: pos - 1.
			ch := stream next.
			^ ch = $} ].
	^ false! !

!XeWriter methodsFor: 'public writing' stamp: 'BernardoContreras 5/27/2012 17:48'!
functionPrototypesComment
	stream
		nextPutAll: '/*** Function Prototypes ***/';
		cr! !

!XeWriter methodsFor: 'public writing' stamp: 'BernardoContreras 5/27/2012 17:47'!
incrementIndentation
	indentationLevel := indentationLevel + 1! !

!XeWriter methodsFor: 'initialize-release' stamp: 'BernardoContreras 5/27/2012 17:50'!
initialize
	super initialize.
	indentationLevel := 0.
	beginningOfLine := true.! !

!XeWriter methodsFor: 'public writing' stamp: 'BernardoContreras 5/27/2012 17:47'!
nextPut: anObject
	self nextPutIndentation.
	stream nextPut: anObject! !

!XeWriter methodsFor: 'public writing' stamp: 'BernardoContreras 5/27/2012 17:47'!
nextPutAll: aCollection
	self nextPutIndentation.
	stream nextPutAll: aCollection! !

!XeWriter methodsFor: 'private' stamp: 'BernardoContreras 5/27/2012 17:47'!
nextPutIndentation
	beginningOfLine
		ifFalse: [ ^ self ].
	stream tab: indentationLevel.
	beginningOfLine := false! !

!XeWriter methodsFor: 'public writing' stamp: 'BernardoContreras 5/27/2012 17:47'!
space
	stream space! !

!XeWriter methodsFor: 'accessing' stamp: 'BernardoContreras 5/27/2012 17:52'!
stream: aStream
	stream := aStream 
	! !
